; ==============================================================================
;	MGSDRV
;
;  Copyright (C) 2020 Takayuki Hara (HRA!)
;  All rights reserved.
;                           http://hraroom.s602.xrea.com/msx/software/mgsp.html
;
;  {\tgEFAі{\tgEFAɊÂč쐬ꂽh́Aȉ̏
;  ꍇɌAĔЕzюgp܂B
;
;  1.\[XR[h`ōĔЕzꍇAL̒쌠\A{ꗗAщL
;    Ɛӏ̂܂܂̌`ŕێ邱ƁB
;  2.oCi`ōĔЕzꍇAЕzɕt̃hLg̎ɁAL
;    쌠\A{ꗗAщLƐӏ܂߂邱ƁB
;  3.ʂɂ鎖ŐȂɁA{\tgEFA̔AяƓIȐi⊈
;    ɎgpȂƁB
;
;  {\tgEFÁA쌠҂ɂāû܂܁v񋟂Ă܂B쌠҂́A
;  ړIւ̓K̕ۏ؁Ai̕ۏ؁A܂Ɍ肳ȂAȂ閾
;  I͈ÖقȕۏؐӔC܂B쌠҂́AR̂킸AQ
;  ̌킸AӔC̍_ł邩iӔCł邩iߎ
;  ̑́js@sׂł邩킸Aɂ̂悤ȑQ\m
;  ĂƂĂA{\tgEFA̎gpɂĔi֕i܂͑pT
;  [rX̒BAgp̑rAf[^̑rAv̑rAƖ̒f܂߁A܂
;  Ɍ肳ȂjڑQAԐڑQAIȑQAʑQAIQA
;  ͌ʑQɂāAؐӔC𕉂Ȃ̂Ƃ܂B
;
;  Note that above Japanese version license is the formal document.
;  The following translation is only for reference.
;
;  Redistribution and use of this software or any derivative works,
;  are permitted provided that the following conditions are met:
;
;  1. Redistributions of source code must retain the above copyright
;     notice, this list of conditions and the following disclaimer.
;  2. Redistributions in binary form must reproduce the above
;     copyright notice, this list of conditions and the following
;     disclaimer in the documentation and/or other materials
;     provided with the distribution.
;  3. Redistributions may not be sold, nor may they be used in a
;     commercial product or activity without specific prior written
;     permission.
;
;  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
;  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
;  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
;  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
;  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
;  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
;  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
;  POSSIBILITY OF SUCH DAMAGE.
; ------------------------------------------------------------------------------
;	Date		Author	Ver		Description
;	2020/9/22	t.hara	1.0		1st release
; ==============================================================================

mgs_music_data	:= 0x8000
mgs_music_size	:= 0x4000
mgs_music_title	:= 0x8008

; ==============================================================================
;	check_mgsdrv
;	input)
;		--
;	output)
;		Zf .... 0: 풓ĂȂ, 1: 풓Ă
;	comment)
;		MGSDRV풓Ă邩ǂׂB
;		풓Ă΁Ao[WԍԂB
;		풓Ăꍇ́Amgs_jump_table, mgs_parameter_block ̏sB
; ==============================================================================
		scope	check_mgsdrv
check_mgsdrv::
		or		a, a
		ld		de, 0xF000					; D=device ID (MGSDRV), E=00h
		call	extbio
		inc		a
		ret		nz							; MGSDRV풓ĂȂꍇ Zf = 0 Ŕ

		; HL  Jump table ̃AhXĂ̂ŁA[J(mgs_jump_table)ɃRs[Ă
		push	bc
		ld		de, mgs_jump_table
		ld		bc, 3 * 5
		ldir

		; parameter block Rs[Ă
		pop		hl
		ld		de, mgs_parameter_block
		ld		bc, 20
		ldir

		; page1  page2  MGSDRVpɐ؂ւ
		ld			h, 0x40
		ld			a, [mgs_id_drvslt]
		call		enaslt
		ld			h, 0x80
		ld			a, [mgs_id_datslt]
		call		enaslt
		ei
		xor			a, a					; Zf = 1
		ret
		endscope

; ==============================================================================
;	MGSDRṼgbN[NNA
; ==============================================================================
		scope		clear_mgsdrv_track_work
clear_mgsdrv_track_work::
		call		stop_music

		di
		ld			hl, [mgs_id_trwsiz]
		ld			c, l
		ld			b, h
		add			hl, hl
		add			hl, hl
		add			hl, hl
		add			hl, hl
		add			hl, bc
		ld			c, l
		ld			b, h
		ld			hl, [mgs_id_trwadr]
		ld			de, [mgs_id_trwadr]
		inc			de
		dec			bc
		xor			a, a
		ld			[hl], a
		ldir
		ei
		ret
		endscope

; ==============================================================================
;	Xbg\MGSDRVpɂ
; ==============================================================================
		scope		change_mgsdrv_slot
change_mgsdrv_slot::
		; change slot of page1 (mgsdrv body)
		ld			h, 0x40
		ld			a, [mgs_id_drvslt]
		call		enaslt

		; change slot of page2 (music data)
		ld			h, 0x80
		ld			a, [mgs_id_datslt]
		call		enaslt

		; change mapper segment of page1
		ld			a, [mgs_id_drvseg]
		call		mapper_put_p1

		; change mapper segment of page2
		ld			a, [mgs_id_datseg]
		call		mapper_put_p2
		ei
		ret
		endscope

; ==============================================================================
;	load_mgs_file
;	input)
;		de .... t@C̃AhX (ASCIIZ)
;	output)
;		Zf .... 0: , 1: s
; ==============================================================================
		scope		load_mgs_file
load_mgs_file::
		ld			[file_name_address], de
		ld			a, [de]
		or			a, a				; Zf = 0:, 1:s
		ret			z					; sȂ甲

		call		stop_music

		; G[ϐNA
		xor			a, a
		ld			[error_status], a
		; open the file
		ld			c, D2F_OPEN
		ld			a, 1				; Disable write access
		ld			de, [file_name_address]
		call		safe_bdos
		ld			a, b
		ld			[file_handle], a
		jp			nz, error_exit

		; read the file
		ld			c, D2F_READ
		ld			de, mgs_music_data
		ld			hl, mgs_music_size
		call		safe_bdos

		; close the file
		ld			c, D2F_CLOSE
		ld			a, [file_handle]
		ld			b, a
		call		safe_bdos

		; G[Ȃ甲
		ld			a, [error_status]
		or			a, a
		jp			nz, error_exit

		; check music data
		ld			hl, 0x8000
		call		mgs_datck
		jp			nz, error_exit

		; clear Music Title area
		ld			hl, (256 + 32) * 8
		ld			bc, 32 * 8
		xor			a, a
		ld			ix, FILVRM
		ld			iy, [exptbl - 1]
		call		CALSLT
		xor			a, a
		inc			a					; Zf = 0:
		ret
error_exit:
		ld			a, 1
		ld			[error_status], a
		xor			a, a				; Zf = 1:s
		ret
		endscope

; ==============================================================================
;	t@CpXt@Cigq܂܂jRs[
;	input)
;		hl .... t@CpX̃AhX (ASCIIZ)
;		de .... Rs[AhX (9byte)
;	output)
;		--
;	break)
;		af, bc, de, hl
; ==============================================================================
		scope		copy_file_name
copy_file_name::
		; Ō̃pXZp[^ \ 
		ld			c, l
		ld			b, h
search_sep:
		ld			a, [hl]
		inc			hl
		or			a, a
		jr			z, exit_search_sep
		cp			a, '\\'
		jr			nz, search_sep
		jr			copy_file_name

exit_search_sep:
		ld			l, c
		ld			h, b
		ld			b, 8
copy_loop:
		ld			a, [hl]
		inc			hl
		or			a, a
		jr			z, exit_copy_loop
		cp			a, '.'
		jr			z, exit_copy_loop
		ld			[de], a
		inc			de
		djnz		copy_loop
exit_copy_loop:
		xor			a, a
		ld			[de], a
		ret
		endscope

; ==============================================================================
;	ȂĐ
;	output)
;		Zf .... 0: s, 1: 
; ==============================================================================
		scope		play_music
play_music::
		call		stop_music

		; check music data
		ld			hl, 0x8000
		call		mgs_datck
		ret			nz

		; music start
		ld			b, -1
		ld			hl, -1
		ld			de, 0x8000
		call		mgs_plyst
		ei
		xor			a, a
		ret
		endscope

; ==============================================================================
;	Ȃ~
; ==============================================================================
		scope		stop_music
stop_music::
		; music stop
		call		change_mgsdrv_slot
		call		mgs_initm
		ret
		endscope

; ==============================================================================
;	WORKAREA
; ==============================================================================
file_name_address::
		dw		0
file_name_copy::
		db		0, 0, 0, 0, 0, 0, 0, 0, 0
file_handle::
		db		0

mgs_jump_table::
mgs_ij_interv::
		db			0xc9, 0xc9, 0xc9
mgs_ij_chgdrv::
		db			0xc9, 0xc9, 0xc9
mgs_ij_revdrv::
		db			0xc9, 0xc9, 0xc9
mgs_ij_calmgs::
		db			0xc9, 0xc9, 0xc9
mgs_ij_chgseg::
		db			0xc9, 0xc9, 0xc9

mgs_parameter_block::
mgs_id_drvslt::			; +0, 1byte: MGSDRV{̂̃Xbg
		db			0
mgs_id_drvseg::			; +1, 1byte: MGSDRV{̂̃ZOg
		db			0
mgs_id_datslt::			; +2, 1byte: tf[^̈̃Xbg
		db			0
mgs_id_datseg::			; +3, 1byte: tf[^̈̃ZOg
		db			0
mgs_id_drvsiz::			; +4, 2bytes: MGSDRV{̂̃TCY
		dw			0
mgs_id_chfomm::			; +6, 1byte: ؂ւp̃Xbg(C)
		db			0
mgs_id_chfome::			; +7, 1byte: ؂ւp̃Xbg(g)
		db			0
mgs_id_mgsver::			; +8, 2bytes: MGSDRṼo[W
		dw			0
mgs_id_mibadr::			; +10, 2bytes: MIBւ̃AhX
		dw			0
mgs_id_trwadr::			; +12, 2bytes: gbN[ÑAhX
		dw			0
mgs_id_trwsiz::			; +14, 2bytes: gbN[ÑTCY
		dw			0
mgs_id_keyasw::			; +16, 1byte: L[荞ݏtO
		db			0
mgs_id_segmax::			; +17, 1byte: mۂȃf[^ZOg̐
		db			0
mgs_id_segnum::			; +18, 1byte: I𒆂̋ȃf[^ԍ
		db			0
mgs_id_segtab::			; +19, 1byte: mۂȃf[^ZOg̃e[u
		db			0
